//  Layout Decoder II
//   Based on  Mr Watch DCC Monitor By yaasan
//      Copyright(C) 2017- Desktop Station Co.,Ltd.
//   from  SpeedMetor(PitIn-S) by TRAINO ★ Ver 2.1 
//
//   2/4  レリース　V0.1  
//        BLUボタンでテストモード開始　
//   2/6  レリース　V0.2
//        マニュアル操作を１回に制限
//        初期値をマニュアルに合わせて変更
//　　　　　ルート設定時、赤スイッチで確定
//        route アドレスをゼロに戻せるように変更
//   4/11  レリース　V0.3
//   4/24  初期値変更　レリース Ver 0.4
//
//       　

const char Version[] = "Ver  0.4";

#include "NmraDcc_v141.h"
#include <Wire.h>
#include "I2CLCDLib.h"
#include <EEPROM.h>
//
// 
//
#define ROUTESIZE 40  // 40 x 16 = 640 byte
#define EEPROMOFFSET3 (1024-16*ROUTESIZE) // 256+32+32 // end = 512+32+30x16= 1024 macro
#define EEPROMOFFSET2 (EEPROMOFFSET3-ROUTESIZE) // macro
#define EEPROMOFFSET1 (EEPROMOFFSET2-16) // basec 256-
//
//      512+256-64= 512+192= 704 => 44１スロット
//      704/16= 44
// 

// definition,configuration
//
//#define DEBUG
////////////// define Layout Decoder hardware 
//
// button definition
//
#define RED 17 // A3 PC3
#define BLU 15 // a1 PC1
#define GRN 6  // PD6
//
// decoder for selecting moter-driver
//
#define DECA 16 //pc2
#define DECB 3 //pd3
#define DECC 4 //pd4
#define OE 5 //pd5
//
// data bus definition
// 
#define DBUS1 8
#define DBUS2 9
#define DBUS3 10
#define DBUS4 11
//
// DCC interface
// 
#define PIN_DCCIN 2
//
// other definition
//
#define DECODER_ADDRESS 3
#define MAX_LOCTABLE 16
#define MAX_ACCTABLE 128
#define MODE_LOC 0
#define MODE_ACC 1
#define MODE_VMON 2
#define MODE_ERR 3
#define MODE_TOTAL 4
#define PULSE_MIN	40
#define PULSE_MAX	200
#define PULSE_BUF_MAX 128

/* DCC SpeedStep 28専用テーブル */
const uint8_t DCC_28SPEEDMAP[29] = {
  0b00000, 0b00010, 0b10010, 0b00011,
  0b10011, 0b00100, 0b10100, 0b00101,
  0b10101, 0b00110, 0b10110, 0b00111,
  0b10111, 0b01000, 0b11000, 0b01001,
  0b11001, 0b01010, 0b11010, 0b01011,
  0b11011, 0b01100, 0b11100, 0b01101,
  0b11101, 0b01110, 0b11110, 0b01111, 0b11111
};
//使用クラスの宣言
NmraDcc	 Dcc;
DCC_MSG	 Packet;
/* LCD functions */
I2CLCDLib LCD;
//Task Schedule
unsigned long gPreviousL5 = 0;
unsigned long gPreviousL1 = 0;
struct LocData {
  uint16_t	mAddr;
  uint16_t  mSpeed;
  uint16_t  mSpeedhex;  // ★ for hexadecimal 
  uint8_t	mDirection;
  uint32_t	mFunction;
};
char message[10]; //　★ DCC message

LocData gLocTable[MAX_LOCTABLE];
uint16_t gAccTable[MAX_ACCTABLE];
uint16_t gAccLatestAddr[4] = {0, 0, 0, 0};
uint16_t gAccLatestDir[4] = {0, 0, 0, 0};
uint16_t gAccLastAddr = 9999;
uint8_t gMode = MODE_LOC;
uint8_t gTopIndex_Loc = 0xFF;
uint8_t gTopIndex_Acc = 0;
uint8_t gWatchMode = 0; // Analogを初期モードにする
uint8_t gButtonStatus = 0;
uint16_t gCount_Err = 0;
uint16_t gCount_Idle = 0;
uint16_t gCount_Reset = 0;
uint16_t gCount_PreMin = 255;
uint16_t gCount_PreMax = 0;
void(* resetFunc) (void) = 0;  //declare reset function at address 0

void ClearTable();
void DisplayFunctionBit(uint32_t inFunctionBits);
void DisplayAccBit(uint16_t inFunctionBits);
uint16_t ReadEdcVoltage();


void updateDccSpeed(word inLocoAddr, uint16_t inAddr, uint8_t inSpeed, uint8_t inDir, uint8_t inSpeedSteps );
// void decodeLocoPacket(uint8_t inPacket1, uint8_t inPacket2); unused
uint16_t getLocAddrIndex(uint16_t inAddr);

unsigned long scale; // ex 150
char flag = 0;
char dbuff[20];
#define UPDATEMS 1000

unsigned char accAddress[16];  // noramry [0,1,2,3]= 1,2,3,4,5
unsigned char routeSelectAddress[ROUTESIZE]; 

//
// out()
//  ch    channel on this board range 1-16
//  dir   0 or 1
//  tt    on-time (ms)
//  brake braking time
//
//
//             case 1: out(ii+1,0,0,BB); break;
//             case 2: out(ii+1,1,0,BB); break;
//
void out(uint8_t ch,unsigned char dr,unsigned short tt,unsigned brake) {
  //
  // set decoder address
  //
  if(tt!=0) {
    LCD.lcd_setCursor(0, 1);sprintf(dbuff,"CH%2d=>",ch);LCD.lcd_printStr(dbuff);
    if(dr==0) LCD.lcd_printStr("/D"); else  LCD.lcd_printStr("|S");
  }
  else
    return; // 最終ロケーション表示は止める　コイルがつながるとうまく表示されない

  switch(ch) {
    case 1:case 2:digitalWrite(DECA, LOW);digitalWrite(DECB, LOW);digitalWrite(DECC, LOW);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc000:");*/   break;
    case 3:case 4:digitalWrite(DECA, HIGH);digitalWrite(DECB, LOW);digitalWrite(DECC, LOW);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc001:");*/    break;
    case 5:case 6:digitalWrite(DECA, LOW);digitalWrite(DECB, HIGH);digitalWrite(DECC, LOW);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc010:");*/    break;
    case 7:case 8:digitalWrite(DECA, HIGH);digitalWrite(DECB, HIGH);digitalWrite(DECC, LOW);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc011:");*/    break;
    case 9:case 10:digitalWrite(DECA, LOW);digitalWrite(DECB, LOW);digitalWrite(DECC, HIGH);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc100:");*/    break;
    case 11:case 12:digitalWrite(DECA, HIGH);digitalWrite(DECB, LOW);digitalWrite(DECC, HIGH);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc101:");*/    break;
    case 13:case 14:digitalWrite(DECA, LOW);digitalWrite(DECB, HIGH);digitalWrite(DECC, HIGH);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc110:");*/    break;
    case 15:case 16:digitalWrite(DECA, HIGH);digitalWrite(DECB, HIGH);digitalWrite(DECC, HIGH);        /*LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("Dc111:");*/    break;
  }

  //
  // if ch > 8 convert location
  //
  if(ch>8) {
    ch = ch/2*2 + 1 - ch%2; // convert odd/even by PCB artwork pattern 
    dr = 1-dr; // convert pol
  }
  //
  switch(ch%2) {
    case 1:
      if(dr==0) {   // DBUS4=HIGH
        //LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("==PASS1=="); 
        digitalWrite(DBUS1, LOW);digitalWrite(DBUS2, LOW);digitalWrite(DBUS3, LOW);digitalWrite(DBUS4, HIGH);
        digitalWrite(OE,LOW);if(tt==0) delayMicroseconds(200); else delay(tt);
        digitalWrite(DBUS1, LOW);digitalWrite(DBUS2,LOW );digitalWrite(DBUS3, LOW);digitalWrite(DBUS4, LOW);
        delay(brake);digitalWrite(OE,HIGH);
   
      }
      else {
        //LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("==PASS2=="); 
        digitalWrite(DBUS1, LOW);digitalWrite(DBUS2, LOW);digitalWrite(DBUS3, HIGH);digitalWrite(DBUS4, LOW);
        digitalWrite(OE,LOW);if(tt==0) delayMicroseconds(200); else delay(tt);
        digitalWrite(DBUS1, LOW);digitalWrite(DBUS2,LOW);digitalWrite(DBUS3, LOW);digitalWrite(DBUS4, LOW);
        delay(brake);digitalWrite(OE,HIGH);
   
      }
      break;
    case 0:
      if(dr==0) {
        //LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("==PASS3=="); 
        digitalWrite(DBUS1, LOW);digitalWrite(DBUS2, HIGH);digitalWrite(DBUS3, LOW);digitalWrite(DBUS4, LOW);
        digitalWrite(OE,LOW);if(tt==0) delayMicroseconds(200); else delay(tt);
        digitalWrite(DBUS1, LOW);digitalWrite(DBUS2,LOW );digitalWrite(DBUS3, LOW);digitalWrite(DBUS4, LOW);
        delay(brake);digitalWrite(OE,HIGH);
   
      }
      else {
        //LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("==PASS4=="); 
        digitalWrite(DBUS1, HIGH);digitalWrite(DBUS2, LOW);digitalWrite(DBUS3, LOW);digitalWrite(DBUS4, LOW);
        digitalWrite(OE,LOW);if(tt==0) delayMicroseconds(200); else delay(tt);
        digitalWrite(DBUS1, LOW);digitalWrite(DBUS2,LOW);digitalWrite(DBUS3, LOW);digitalWrite(DBUS4, LOW);
        delay(brake);digitalWrite(OE,HIGH);
      }
      break;    

  }
  //delay(100); 
}

#define PP 100 // POINT on time
#define BB 3   // brake band

//
// Program starts here
//
int ii;
unsigned char index;
void setup() {
  ClearTable();
  // Init button interface
  pinMode(RED, INPUT); //Button
  pinMode(BLU, INPUT); //Button
  pinMode(GRN, INPUT); //Button
  digitalWrite(RED, 1); //key pullup
  digitalWrite(BLU, 1); //key pullup　
  digitalWrite(GRN, 1); //key pullup　
  // Init Decoder(HC138)
  pinMode(DECA, OUTPUT);
  pinMode(DECB, OUTPUT);
  pinMode(DECC, OUTPUT);
  pinMode(OE, OUTPUT);
  digitalWrite(DECA, LOW);
  digitalWrite(DECB, LOW);
  digitalWrite(DECC, LOW);
  digitalWrite(OE, HIGH);
  // Init databus for moter driver
  pinMode(DBUS1, OUTPUT);
  pinMode(DBUS2, OUTPUT);
  pinMode(DBUS3, OUTPUT);
  pinMode(DBUS4, OUTPUT);
  digitalWrite(DBUS1, LOW);
  digitalWrite(DBUS2, HIGH);
  digitalWrite(DBUS3, LOW);
  digitalWrite(DBUS4, HIGH);
  // 
  pinMode(A0, OUTPUT);
  digitalWrite(A0, 0); //Reset High for display unit
  delay(50);
  digitalWrite(A0, 1); //Reset High for display unit
  delay(50);
  //
  // init data
  /* LCD init */
  LCD.begin();
  
  LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Power ON"); 

  //シリアル通信開始
  Serial.begin(115200);
  Serial.println("TRAINO LAYOUT DECODER for KATO POINT ");
  // 
  //
  // Load configuration
  //
  for(index=0;index<16;index++) 
    accAddress[index] = EEPROM.read(index + EEPROMOFFSET1);
  
  for(index=0;index<ROUTESIZE;index++) 
    routeSelectAddress[index] = EEPROM.read(index + EEPROMOFFSET2);

  //
  // clear mode
  //
  if (digitalRead(BLU) == LOW) {
    LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Start   "); 
    LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("ClearDB?"); 
    for (; digitalRead(BLU) == LOW;); // wait release switch
    LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("        "); 
    LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("        "); 
    delay(1000);
    LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("PressBLU"); 
    LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("to Clear"); 
    
    for(;;) {
      if (digitalRead(BLU) == LOW) {
        LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("        "); 
        LCD.lcd_setCursor(0, 1);LCD.lcd_printStr(".working"); 

        // Set channnel table
        for(index=0;index<16;index++) 
            EEPROM.write( index + EEPROMOFFSET1, index+1 );

        // claer route table 
        for(index=0;index<ROUTESIZE;index++)
            //EEPROM.write( index + EEPROMOFFSET2, 0  ) ;
            EEPROM.write( index + EEPROMOFFSET2, index+101  ) ;
        
        // clear route table 
        for(unsigned short indexx=0;indexx<(ROUTESIZE*16);indexx++)
            EEPROM.write( indexx + EEPROMOFFSET3, 0 ) ;


        // add route table set
        // route1
        for(unsigned short indexx=0;indexx<(16*1);indexx++)
            EEPROM.write( indexx + EEPROMOFFSET3, 1 ) ;
        // route2
        for(unsigned short indexx=16*1;indexx<(16*2);indexx++)
            EEPROM.write( indexx + EEPROMOFFSET3, 2 ) ;

        // route 3
        EEPROM.write( 0+16*2 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 2+16*2 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 4+16*2 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 6+16*2 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 8+16*2 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 10+16*2 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 12+16*2 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 14+16*2 + EEPROMOFFSET3, 1 ) ;
        
        // route 4
        EEPROM.write( 0+16*3 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 2+16*3 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 4+16*3 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 6+16*3 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 8+16*3 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 10+16*3 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 12+16*3 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 14+16*3 + EEPROMOFFSET3, 2 ) ;
        
        // route 5
        EEPROM.write( 0+16*4 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 2+16*4 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 4+16*4 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 6+16*4 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 8+16*4 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 10+16*4 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 12+16*4 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 14+16*4 + EEPROMOFFSET3, 2 ) ;

         // route 6
        EEPROM.write( 0+16*5 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 2+16*5 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 4+16*5 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 6+16*5 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 8+16*5 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 10+16*5 + EEPROMOFFSET3, 1 ) ;
        EEPROM.write( 12+16*5 + EEPROMOFFSET3, 2 ) ;
        EEPROM.write( 14+16*5 + EEPROMOFFSET3, 1 ) ;
       
         LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("        "); 
         LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("....Done"); 
         delay(1000);
         for(;digitalRead(BLU) == LOW;);          

         goto initdone;
      }
    }
  }
initdone:

  //
  // test mode
  //
  if (digitalRead(GRN) == LOW) {
    //
    // Conf mode start
    //
    LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Start   "); 
    LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("SelfTest"); 
    delay(2000);
    for (; digitalRead(GRN) == LOW;); // wait release switch
    delay(2000);

    for(;;) {
      LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Testing "); 
      for(unsigned char c=1;c<=16;c++) {
        out(c,0,PP,BB); delay(1000);
        out(c,1,PP,BB); delay(1000);
      }
      LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("        "); 
      delay(1000);
      if (digitalRead(GRN) == LOW) break;
    }
  }
  //
  // conf mode
  //
  if (digitalRead(RED) == LOW) {
    //
    // Conf mode start
    //
    LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Layout  "); 
    LCD.lcd_setCursor(0, 1);LCD.lcd_printStr(" Decoder"); 
    delay(2000);
    LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("byTRAINO"); 
    LCD.lcd_setCursor(0, 1);LCD.lcd_printStr(Version); 
    for (; digitalRead(RED) == LOW;); // wait release switch
    delay(2000);

    // CH address configuration
    for(index=0;index<16;index++) {
      for (;digitalRead(RED) != LOW;delay(100)) {
        LCD.lcd_setCursor(0, 0);sprintf(message, "CH   #%2d",(unsigned int)index+1);LCD.lcd_printStr(message); 
        LCD.lcd_setCursor(0, 1);sprintf(message, "ADR<%3d>", (unsigned int)accAddress[index]);LCD.lcd_printStr(message); 
        if (digitalRead(BLU) == LOW) {if (accAddress[index]>1) --accAddress[index]; delay(100);}
        if (digitalRead(GRN) == LOW) {if (accAddress[index]<250) ++accAddress[index]; delay(100);}
      }
      LCD.lcd_setCursor(7, 1);LCD.lcd_printStr("*");delay(100); 
      for (; digitalRead(RED) == LOW;);
      EEPROM.write(index + EEPROMOFFSET1, accAddress[index]);
      delay(100);
    }

    // inquire yes or no
    LCD.lcd_setCursor(0, 0);sprintf(message, "Modify  ",(unsigned int)index+1);LCD.lcd_printStr(message);
    for (ii=0;digitalRead(RED) != LOW;delay(100)) {
      LCD.lcd_setCursor(0, 1); 
      if(ii!=0) LCD.lcd_printStr("Route<Y>"); else LCD.lcd_printStr("Route<N>"); 

      if (digitalRead(BLU) == LOW) {ii=0; delay(100);}
      if (digitalRead(GRN) == LOW) {ii=1; delay(100);}
    }
    LCD.lcd_setCursor(7, 1);LCD.lcd_printStr("*");delay(100); 
    for (; digitalRead(RED) == LOW;);
    delay(100);
    if(ii!=0) {
      // 
      // route address configuration
      //   ii yes/no
      //
      for(index=0;index<ROUTESIZE;index++) {
        //
        // index <= route number
        //
        for (;digitalRead(RED) != LOW;delay(100)) {
          LCD.lcd_setCursor(0, 0);sprintf(message, "Route#%2d",(unsigned int)index+1);LCD.lcd_printStr(message);
          LCD.lcd_setCursor(0, 1);
          if(routeSelectAddress[index]==0)
            sprintf(message, "ADR<--->");
          else
            sprintf(message, "ADR<%3d>", (unsigned int)routeSelectAddress[index]);
          LCD.lcd_printStr(message); 
          
          if (digitalRead(BLU) == LOW) {if (routeSelectAddress[index]>=1) --routeSelectAddress[index]; delay(100);}
          if (digitalRead(GRN) == LOW) {if (routeSelectAddress[index]<250) ++routeSelectAddress[index]; delay(100);}
        }
        LCD.lcd_setCursor(7, 1);LCD.lcd_printStr("*");delay(100); 
        for (; digitalRead(RED) == LOW;);
        EEPROM.write(index + EEPROMOFFSET2, routeSelectAddress[index]);
        delay(100);
  
        // if address == 0 then terminalte configuration
        if(routeSelectAddress[index]==0) break;
  
        // inquire yes or no
        LCD.lcd_setCursor(0, 0);sprintf(message, "Route#%2d",(unsigned int)index+1);LCD.lcd_printStr(message);
        for (ii=0;digitalRead(RED) != LOW;delay(100)) {
          LCD.lcd_setCursor(0, 1); 
          if(ii!=0) LCD.lcd_printStr("Modfy<Y>"); else LCD.lcd_printStr("Modfy<N>"); 
    
          if (digitalRead(BLU) == LOW) {ii=0; delay(100);}
          if (digitalRead(GRN) == LOW) {ii=1; delay(100);}
        }
        LCD.lcd_setCursor(7, 1);LCD.lcd_printStr("*");delay(100); 
        for (; digitalRead(RED) == LOW;);
        delay(100);
        LCD.lcd_setCursor(0, 0);sprintf(message, "Route#%2d",(unsigned int)index+1);LCD.lcd_printStr(message);
  
        if(ii!=0) {   //ii１とindexの使い方が混乱？
            /////// change macro CH conf
            // macro action configuration
            unsigned int index2,data;
            for(index2=0;index2<16;index2++) {
              //data = EEPROM.read(EEPROMOFFSET3+index*16+index2);  
              //data = routeSelectTable[index][index2];
              data = EEPROM.read(EEPROMOFFSET3+index*16+index2);
              for (;digitalRead(RED) != LOW;delay(100)) {
                LCD.lcd_setCursor(0, 1);sprintf(message, "CH%2d=",(unsigned int)index2+1);LCD.lcd_printStr(message); 
                switch(data)  {
                  case 0: LCD.lcd_printStr("<->");break;
                  case 1: LCD.lcd_printStr("<D>");break;
                  case 2: LCD.lcd_printStr("<S>");break;
                }
                sprintf(message, "<%2d>", (unsigned int)data);LCD.lcd_printStr(message); 
                if (digitalRead(BLU) == LOW) {if (data>0) --data; delay(100);}
                if (digitalRead(GRN) == LOW) {if (data<2) ++data; delay(100);}
              }
              LCD.lcd_setCursor(7, 1);LCD.lcd_printStr("*");delay(100); 
              for (; digitalRead(RED) == LOW;);
              //EEPROM.write(EEPROMOFFSET3+index*16+index2, data);
              // routeSelectTable[index][index2]=data;
              EEPROM.write(EEPROMOFFSET3+index*16+index2,data);
              
              delay(100);
            }
            /////// change macro CH conf
        }
      } // end of route addres conf
  
    }

    LCD.lcd_setCursor(0, 0);
    LCD.lcd_printStr("Config  ");
    LCD.lcd_setCursor(0, 1);
    LCD.lcd_printStr("Complete");

  }
  // End of conf.
  //

  Serial.println("Start");

  
  // Load databese
  for(index=0;index<16;index++) {
    accAddress[index] = EEPROM.read(index + EEPROMOFFSET1);
    sprintf(dbuff,"ACC ADRS[%d]=%d,",(unsigned int)index,(unsigned int)accAddress[index]);
    Serial.println(dbuff);
  }

  // Load databese
  for(ii=0;ii<ROUTESIZE;ii++) {
    routeSelectAddress[ii] = EEPROM.read(ii + EEPROMOFFSET2);
    sprintf(dbuff,"ROT ADRS [%d]=%d,",(unsigned int)index,(unsigned int)accAddress[ii]);
    Serial.println(dbuff);
  }
  
  // Setup which External Interrupt, the Pin it's associated with that we're using, disable pullup.
  Dcc.pin(0, PIN_DCCIN, 0);
  // Call the main DCC Init function to enable the DCC Receiver
  //  Dcc.init( 140, 10, 0 , 0 );


  //void NmraDcc::init( uint8_t ManufacturerId, uint8_t VersionId, uint8_t Flags, uint8_t OpsModeAddressBaseCV )
  // Flag values to be logically ORed together and passed into the init() method
  //#define FLAGS_MY_ADDRESS_ONLY        0x01  // Only process DCC Packets with My Address
  //#define FLAGS_OUTPUT_ADDRESS_MODE   0x40  // CV 29/541 bit 6
  //#define FLAGS_DCC_ACCESSORY_DECODER 0x80  // CV 29/541 bit 7
  
  //  Dcc.init( 140 , 100,   FLAGS_MY_ADDRESS_ONLY , 0 ); 
  Dcc.init( 140 , 100,   FLAGS_DCC_ACCESSORY_DECODER , 0 ); 

  LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("RunLD-KP"); 
  LCD.lcd_setCursor(0, 1);LCD.lcd_printStr("         "); 

}

uint8_t eventScheduler[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // event at ebach ch 
uint8_t lastdir[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};  // 

unsigned int manualView = 0;
unsigned int manualRoute = 0;
unsigned int lastRoute = 1;
void loop()
{
  uint8_t aUpdate = 0;
  unsigned char btn = 0;
  uint8_t ii = 0;

  // You MUST call the NmraDcc.process() method frequently from the Arduino loop() function for correct library operation
  Dcc.process();
  //
  // コールバック関数で設定されたバッファから
  // CH1-16のポイントを動かす（もしくは一瞬全開の方向に流す）
  //
  for(ii=0;ii<16;ii++) {
    switch(eventScheduler[ii]) {
       case 0: // no command 
         switch(lastdir[ii]) {
             default:  break;
             case 1: out(ii+1,0,0,BB); break;
             case 2: out(ii+1,1,0,BB); break;
         }      
         break;
       case 1:
          out(ii+1,0,PP,BB); 
          LCD.lcd_printStr("D:  "); 
          eventScheduler[ii]=0;
          lastdir[ii] = 1;
          //manualView=0;
          Dcc.process();   // append 
         break;
       case 2:
          out(ii+1,1,PP,BB); 
          LCD.lcd_printStr("S:  "); 
          eventScheduler[ii]=0;
          lastdir[ii] = 2;
          //manualView=0;
          Dcc.process();   // append 
         break;
    }
  }
  // 100mSごとにスイッチをスキャン
  //
  if ( (millis() - gPreviousL1) >= 100)
  {
    //Reset task ★処理の最初に変更
    gPreviousL1 = millis();
    //
    // RED
    //
    if(digitalRead(RED) == LOW ) {
      // if (++manualView > 17) manualView=1; 先に増やさない

        if( manualRoute!=0) {
           // if (++manualView > 17) manualView=1;            // do route action
           for(unsigned int j=0;j<16;j++)
                eventScheduler[j]  = EEPROM.read(EEPROMOFFSET3+(manualRoute-1)*16+j);
          LCD.lcd_setCursor(7, 0);LCD.lcd_printStr("*");
          delay(100);
          for(;digitalRead(RED) == LOW;) Dcc.process();// ver 0.3
          LCD.lcd_setCursor(0, 0);sprintf(message, "Route#%2d=",(unsigned int)manualRoute);LCD.lcd_printStr(message); 
          lastRoute = manualRoute;
          manualRoute=0;
         
        }
        else {
          if (++manualView > 17) manualView=1; 
          if(manualView == 17) {
            LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Route<?>");
            delay(100);
            for(;digitalRead(RED) == LOW;) Dcc.process();            
          } else {
            LCD.lcd_setCursor(0, 0);sprintf(message, "MAN CH%2d=",(unsigned int)manualView);LCD.lcd_printStr(message); 
            manualRoute=0; 
            delay(100);
          }
        }
    }
    //
    // Blue
    //    
    if (digitalRead(BLU) == LOW) {
      if(manualView!=0) {
        if(manualView!=17)
         {   out(manualView,0,PP,BB);           lastdir[manualView-1] = 1;}
        else 
        {
            if(manualRoute==0) manualRoute=lastRoute;
            else {
              if(manualRoute>=2) manualRoute--;
            }
            if(manualRoute<10) {
              LCD.lcd_setCursor(0, 0);sprintf(message, "Route<%d>",(unsigned int)manualRoute);LCD.lcd_printStr(message); 
            } else {
              LCD.lcd_setCursor(0, 0);sprintf(message, "Rout<%2d>",(unsigned int)manualRoute);LCD.lcd_printStr(message); 
            }
          }
          delay(100);
          // cancelation 
          if (digitalRead(GRN) == LOW) {
            LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Route<->");
            for(;digitalRead(BLU) == LOW || digitalRead(GRN) == LOW ;) Dcc.process(); 
            manualRoute=0;
            LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Route<?>");
          }
      }
    }
    //
    // GREEN
    //
    if (digitalRead(GRN) == LOW) {
      if(manualView!=0) {
        //Serial.println("xxxxgg");
        if(manualView!=17)
          {   out(manualView,1,PP,BB);           lastdir[manualView-1] = 2;}
        else 
          {
            if(manualRoute==0) 
             manualRoute=lastRoute;
            else {
              if(++manualRoute>ROUTESIZE) manualRoute=ROUTESIZE;
            }
            if(manualRoute<10) {
              LCD.lcd_setCursor(0, 0);sprintf(message, "Route<%d>",(unsigned int)manualRoute);LCD.lcd_printStr(message); 
            } else {
              LCD.lcd_setCursor(0, 0);sprintf(message, "Rout<%2d>",(unsigned int)manualRoute);LCD.lcd_printStr(message); 
            }
          }
          delay(100);
          // cancelation 
          if (digitalRead(BLU) == LOW) {
            LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Route<->");
            for(;digitalRead(BLU) == LOW || digitalRead(GRN) == LOW ;) Dcc.process(); 
            manualRoute=0;
            LCD.lcd_setCursor(0, 0);LCD.lcd_printStr("Route<?>");
          }
      }
    } 
    gPreviousL1 = millis();     
  }
  else {
  
    if ( ((millis() - gPreviousL5) >= 600) || (aUpdate == 1))
  
    {
      //Reset task
      gPreviousL5 = millis();
  
      //Main Task
      //OutputResults();
  
      btn = 0;
    }
  }
}


  
extern void notifyDccSpeed( uint16_t Addr, DCC_ADDR_TYPE AddrType, uint8_t Speed, DCC_DIRECTION Dir, DCC_SPEED_STEPS SpeedSteps ){

    // Serial.println("running"); OK!
    //　not used
}


int PINOUT[]= {0,14,15,16,17,18,19,13,3};


extern void notifyDccFunc(uint16_t Addr, DCC_ADDR_TYPE AddrType, FN_GROUP FuncGrp, uint8_t FuncState) {
  switch(FuncGrp)  {
    case FN_0_4:  //Function Group 1 F0 F4 F3 F2 F1
      //exec_function( 0, FunctionPin0, (FuncState & FN_BIT_00)>>4 );
      exec_function( 1, PINOUT[1], (FuncState & FN_BIT_01));
      exec_function( 2, PINOUT[2], (FuncState & FN_BIT_02)>>1);
      exec_function( 3, PINOUT[3], (FuncState & FN_BIT_03)>>2 );
      exec_function( 4, PINOUT[4], (FuncState & FN_BIT_04)>>3 );
      break;

    case FN_5_8:  //Function Group 1 S FFFF == 1 F8 F7 F6 F5  &  == 0  F12 F11 F10 F9 F8
      exec_function( 5, PINOUT[5], (FuncState & FN_BIT_05));
      exec_function( 6, PINOUT[6], (FuncState & FN_BIT_06)>>1 );
      exec_function( 7, PINOUT[7], (FuncState & FN_BIT_07)>>2 );
      exec_function( 8, PINOUT[8], (FuncState & FN_BIT_08)>>3 );
      break;

    case FN_9_12:
      //exec_function( 9, FunctionPin9, (FuncState & FN_BIT_09));
      //exec_function( 10, FunctionPin10, (FuncState & FN_BIT_10)>>1 );
      //exec_function( 11, FunctionPin11, (FuncState & FN_BIT_11)>>2 );
      //exec_function( 12, FunctionPin12, (FuncState & FN_BIT_12)>>3 );
      break;

    case FN_13_20:   //Function Group 2 FuncState == F20-F13 Function Control
      //exec_function( 13, FunctionPin13, (FuncState & FN_BIT_13));
      //exec_function( 14, FunctionPin14, (FuncState & FN_BIT_14)>>1 );
      //exec_function( 15, FunctionPin15, (FuncState & FN_BIT_15)>>2 );
      //exec_function( 16, FunctionPin16, (FuncState & FN_BIT_16)>>3 );
      break;

    case FN_21_28:
      break;
      
  }
}


void exec_function (int function, int pin, int FuncState){
  Serial.print(function,DEC);
  digitalWrite (pin, FuncState);
}




void notifyDccSigState( uint16_t Addr, uint8_t OutputIndex, uint8_t State) {
  Serial.print("notifyDccSigState: ") ;
  Serial.print(Addr,DEC) ;
  Serial.print(',');
  Serial.print(OutputIndex,DEC) ;
  Serial.print(',');
  Serial.println(State, HEX) ;

}
//
// This function is called whenever a normal DCC Turnout Packet is received
//
const unsigned char ccmacroComand[16][8] = {  // CCCC AAAA 
  0x00+1, 0x10+1, 0x20+2, 0x30+1, 0x40+2, 0x50+1, 0x60+2, 0x70+1,
  0x90+1, 0xA0+2, 0xB0+1, 0xC0+2, 0xd0+1, 0xe0+2, 0xf0+1, 0x80+2,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0,
  0x10+1, 0x20+2, 0,0,0,0,0,0
};


int i;
void notifyDccAccState( uint16_t Addr, uint16_t BoardAddr, uint8_t OutputAddr, uint8_t State)
{
  uint16_t aAccAdress = Addr;
  uint8_t aDir = (OutputAddr & 0b001);
  
  Serial.print("notifyDccAccState: ") ;
  Serial.print(Addr,DEC) ;
  Serial.print(",BAdr:");
  Serial.print(BoardAddr,DEC) ;
  Serial.print(",OAdr:");
  Serial.print(OutputAddr,DEC) ;
  Serial.print(", Target Adr:");
  Serial.print(aAccAdress,DEC) ;
  Serial.print(",");
  Serial.println(State, HEX) ;

  // check tabel()
  //
  for(i=0;i<16;i++)
     if(Addr == accAddress[i])  {
        manualView=0;manualRoute=0;
        eventScheduler[i] = 1+ OutputAddr%2;
        //LCD.lcd_setCursor(0, 0);sprintf(message, "REQ CH%2d",(unsigned int)i+1);LCD.lcd_printStr(message);         
        LCD.lcd_setCursor(0, 0);sprintf(message, "AcAD=%3d",(unsigned int)Addr);LCD.lcd_printStr(message);         
     }
  //
  // check route tablel
  //
  for(i=0;i<ROUTESIZE;i++) {
      if(Addr == routeSelectAddress[i]) {
        manualView=0;manualRoute=0;
        LCD.lcd_setCursor(0, 0);sprintf(message, "A%3d/R%2d",(unsigned int)Addr,i+1);LCD.lcd_printStr(message);         
        for(unsigned int j=0;j<16;j++) {
            //eventScheduler[macroComand[i][j]/16] = macroComand[i][j]%16;  //   -1 <=inportant
            //eventScheduler[j] = routeSelectTable[i][j];  //   -1 <=inportant

             eventScheduler[j]  = EEPROM.read(EEPROMOFFSET3+i*16+j);

                          
            Serial.print("Write schedule index") ;
            //Serial.print(macroComand[i][j]/16) ;
            Serial.print("|") ;
            //Serial.println(macroComand[i][j]%16) ;
          }
        }
  }       
}

///////////


void ClearTable()
{
  for ( int i = 0; i < MAX_LOCTABLE; i++)
  {
    gLocTable[i].mAddr = 0;
    gLocTable[i].mSpeed = 0;
    gLocTable[i].mDirection = 0;
    gLocTable[i].mFunction = 0;
  }
}

void DisplayFunctionBit(uint32_t inFunctionBits)
{

  for ( int i = 0; i < 29; i++)
  {
    if ( bitRead(inFunctionBits, i) == 0)
    {
      Serial.print(".");
    }
    else
    {
      Serial.print("O");
    }

  }
}

void DisplayAccBit(uint16_t inFunctionBits)
{

  for ( int i = 0; i < 16; i++)
  {
    if ( bitRead(inFunctionBits, i) == 0)
    {
      Serial.print(".");
    }
    else
    {
      Serial.print("O");
    }

  }
}

/* 全DCCメッセージを受信 */
void notifyDccMsg( DCC_MSG * Msg)
{
  uint8_t aErrorbyte = 0;
  uint16_t aLocoAddr = 0;
  uint16_t aAccAddr = 0;


  /* エラーチェック */
  for (uint8_t i = 0; i < Msg->Size; i++)
  {
    aErrorbyte = aErrorbyte ^ Msg->Data[i];
  }

  message[0] = Msg->Size;
  for (uint8_t i = 0; i < Msg->Size; i++)
  {
    message[i + 1] = Msg->Data[i];
  }


  if ( aErrorbyte != 0)
  {
    if ( gCount_Err < 65535)
    {
      gCount_Err++;
    }

    return;
  }
  else
  {
    gWatchMode = 1;
  }

  /* プリアンブル数計算 */
  if ( Msg->PreambleBits < gCount_PreMin)
  {
    gCount_PreMin = Msg->PreambleBits;
  }
  else if ( Msg->PreambleBits > gCount_PreMax)
  {
    gCount_PreMax = Msg->PreambleBits;
  }


  /* パケットチェック */
  switch (Msg->Data[0])
  {
    case 0x00:
      //Broadcast

      if ( Msg->Data[1] == 0x00)
      {
        gCount_Reset++;
      }
      else
      {
        /* その他のBroadcast処理 */
      }

      break;

    case 0xFF:
      //Idle packet
      gCount_Idle++;
      break;

    default:

      if ( Msg->Data[0] <= 127)
      {
        /* SHORTアドレスロコの操作 */
        aLocoAddr = Msg->Data[0];

        decodeLocoPacket(aLocoAddr, Msg->Data[1], Msg->Data[2]);


      }
      else if (( Msg->Data[0] >= 128) && ( Msg->Data[0] <= 191))
      {
        /* アクセサリ */
        aAccAddr = (((Msg->Data[0] & 0b111111) - 1) * 4) + ((7 - (Msg->Data[1] >> 4) & 0b111) << 8) +  (((Msg->Data[1] >> 1) & 0b11));


        if ( (Msg->Data[1] & 1) == 0)
        {
          gAccTable[ aAccAddr >> 4 ] = gAccTable[ aAccAddr >> 4 ] & (~(1 << (aAccAddr & 0xFFFF)) & 0xFFFF);


          if ( aAccAddr != gAccLastAddr)
          {
            gAccLatestAddr[3] = gAccLatestAddr[2];
            gAccLatestDir[3] = gAccLatestDir[2];

            gAccLatestAddr[2] = gAccLatestAddr[1];
            gAccLatestDir[2] = gAccLatestDir[1];

            gAccLatestAddr[1] = gAccLatestAddr[0];
            gAccLatestDir[1] = gAccLatestDir[0];

            gAccLatestAddr[0] = aAccAddr + 1;
            gAccLatestDir[0] = 0;
          }
          else
          {
            gAccLatestDir[0] = 0;
          }

          //uiPacketInfo.innerText = uiPacketInfo.innerText + ", direction is diverse.";
        }
        else
        {
          gAccTable[ aAccAddr >> 4 ] = gAccTable[ aAccAddr >> 4 ] | (1 << (aAccAddr & 0xFFFF)) ;
          //uiPacketInfo.innerText = uiPacketInfo.innerText + ", direction is straight.";

          if ( aAccAddr != gAccLastAddr)
          {
            gAccLatestAddr[3] = gAccLatestAddr[2];
            gAccLatestDir[3] = gAccLatestDir[2];

            gAccLatestAddr[2] = gAccLatestAddr[1];
            gAccLatestDir[2] = gAccLatestDir[1];

            gAccLatestAddr[1] = gAccLatestAddr[0];
            gAccLatestDir[1] = gAccLatestDir[0];

            gAccLatestAddr[0] = aAccAddr + 1;
            gAccLatestDir[0] = 1;
          }
          else
          {
            gAccLatestDir[0] = 1;
          }
        }

        gAccLastAddr = aAccAddr;


      }
      else if (( Msg->Data[0] >= 192) && ( Msg->Data[0] <= 231))
      {
        /* LONGアドレスロコの操作 */
        aLocoAddr = ((Msg->Data[0] - 192) << 8) + Msg->Data[1];

        decodeLocoPacket(aLocoAddr, Msg->Data[2], Msg->Data[3]);
      }
      else if (( Msg->Data[0] >= 232) && ( Msg->Data[0] <= 254))
      {
        /* 予約 */

      }



      break;

  }

}

void decodeLocoPacket(word inLocoAddr, uint8_t inPacket1, uint8_t inPacket2)
{
  uint8_t aSpeed;
  uint8_t aIndex = getLocAddrIndex(inLocoAddr);

  switch (inPacket1 >> 5)
  {
    case 0b000:
      break;

    case 0b001:

      switch (inPacket1 & 0b11111)
      {
        case 31:

          aSpeed = inPacket2 & 0b01111111;

          if ( aSpeed > 1)
          {
            aSpeed = aSpeed - 1;
          }

          /* リスト更新 */
          updateDccSpeed( inLocoAddr, aSpeed, (inPacket2 >> 7) & 1, 127 );
          break;
      }
      break;

    case 0b010:
      //REV

      aSpeed = inPacket1 & 0b11111;

      for (int i = 0; i < 29; i++)
      {
        if ( aSpeed == DCC_28SPEEDMAP[i])
        {
          /* リスト更新 */
          updateDccSpeed( inLocoAddr, i, 0, 29 );

          break;
        }
      }

      break;
    case 0b011:
      //FWD

      aSpeed = inPacket1 & 0b11111;

      for (int i = 0; i < 29; i++)
      {
        if ( aSpeed == DCC_28SPEEDMAP[i])
        {
          /* リスト更新 */
          updateDccSpeed( inLocoAddr, i, 1, 29 );

          break;
        }
      }

      break;

    case 0b100:
      bitWrite( gLocTable[aIndex].mFunction, 0, (inPacket1 >> 4) & 1);
      bitWrite( gLocTable[aIndex].mFunction, 1, (inPacket1 >> 0) & 1);
      bitWrite( gLocTable[aIndex].mFunction, 2, (inPacket1 >> 1) & 1);
      bitWrite( gLocTable[aIndex].mFunction, 3, (inPacket1 >> 2) & 1);
      bitWrite( gLocTable[aIndex].mFunction, 4, (inPacket1 >> 3) & 1);
      break;

    case 0b101:

      switch ((inPacket1 >> 4) & 1)
      {
        case 1:
          bitWrite( gLocTable[aIndex].mFunction, 5, (inPacket1 >> 0) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 6, (inPacket1 >> 1) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 7, (inPacket1 >> 2) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 8, (inPacket1 >> 3) & 1);
          break;
        case 0:
          bitWrite( gLocTable[aIndex].mFunction, 9, (inPacket1 >> 0) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 10, (inPacket1 >> 1) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 11, (inPacket1 >> 2) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 12, (inPacket1 >> 3) & 1);
          break;
      }
      break;

    case 0b110:


      switch (inPacket1 & 0b11111)
      {
        case 30:
          bitWrite( gLocTable[aIndex].mFunction, 13, (inPacket2 >> 0) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 14, (inPacket2 >> 1) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 15, (inPacket2 >> 2) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 16, (inPacket2 >> 3) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 17, (inPacket2 >> 4) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 18, (inPacket2 >> 5) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 19, (inPacket2 >> 6) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 20, (inPacket2 >> 7) & 1);
          break;

        case 31:
          bitWrite( gLocTable[aIndex].mFunction, 21, (inPacket2 >> 0) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 22, (inPacket2 >> 1) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 23, (inPacket2 >> 2) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 24, (inPacket2 >> 3) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 25, (inPacket2 >> 4) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 26, (inPacket2 >> 5) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 27, (inPacket2 >> 6) & 1);
          bitWrite( gLocTable[aIndex].mFunction, 28, (inPacket2 >> 7) & 1);
          break;
      }
  }



}

uint16_t getLocAddrIndex(uint16_t inAddr)
{
  uint16_t aIndex = 0xFFFF;

  for ( int i = 0; i < MAX_LOCTABLE; i++)
  {
    if ( (gLocTable[i].mAddr == inAddr) || (gLocTable[i].mAddr == 0) )
    {

      gLocTable[i].mAddr = inAddr;

      aIndex = i;

      break;
    }
  }

  return aIndex;
}

void updateDccSpeed( uint16_t inAddr, uint8_t inSpeed, uint8_t inDir, uint8_t inSpeedSteps )
{

  uint16_t aSpeed = 0, hSpeed = 0;

  for ( int i = 0; i < MAX_LOCTABLE; i++)
  {
    if ( (gLocTable[i].mAddr == inAddr) || (gLocTable[i].mAddr == 0) )
    {

      gLocTable[i].mAddr = inAddr;

      if ( inSpeed >= 1)
      {
        aSpeed = ((uint16_t)inSpeed * 100) / (uint16_t)(inSpeedSteps - 1); // ★　スピードステップ-1で計算する
        hSpeed = inSpeed;
      }
      else
      {
        hSpeed = aSpeed = 0;
      }


      if ( (aSpeed != gLocTable[i].mSpeed) || (gLocTable[i].mDirection != inDir))
      {
        gLocTable[i].mSpeed = aSpeed;
        gLocTable[i].mSpeedhex = hSpeed; // ★1
        gLocTable[i].mDirection = inDir;

        gTopIndex_Loc = i;

      }


      /* for文終了 */
      break;
    }


  }
}


uint16_t ReadEdcVoltage()
{

  //電圧換算
  // 1k / 11k  y=((x*11*5)/1/1024)
  uint16_t aVolt = analogRead(A2);

  //Limit
  if ( aVolt > 922)
  {
    //30Vで打ち止め
    aVolt = 922;
  }

  aVolt = aVolt >> 2;

  aVolt = (aVolt * 301) >> 7;

  if ( aVolt > 255)
  {
    //UCに入るサイズにリミット(25.5V)
    aVolt = 255;
  }

  return aVolt;

}
